=== debian/changelog ===
docker.io (18.06.1-0ubuntu1) cosmic; urgency=medium

  * Update to 18.06.1 upstream release (LP: #1794396)
    - drop "fix-btrfs-constants.patch" (applied upstream)
  * Update debconf to prompt more aggressively (LP: #1784602)
    1. does not prompt on initial install (but does start the daemon)
    2. does prompt on every reinstall / upgrade (if the daemon is running)
    3. does prompt during "dpkg-reconfigure docker.io" (but does _not_
       [re]start the daemon)
    4. works properly with DEBIAN_FRONTEND=noninteractive -- user's
       previous/stored answer to the question automatically applies with no
       prompt
  * Check if "docker" group exists before creating it (LP: #1769911)

 -- Tianon Gravi <tianon@debian.org>  Mon, 24 Sep 2018 15:42:19 -0700

docker.io (17.12.1-0ubuntu6) cosmic; urgency=medium

  * d/tests/docker-in-lxd: Avoid startup race and drop lxd-client depends

 -- Stéphane Graber <stgraber@ubuntu.com>  Sat, 15 Sep 2018 03:07:49 +0200

docker.io (17.12.1-0ubuntu5) cosmic; urgency=medium

  * Fix ftbfs by cherry-picking https://github.com/containerd/btrfs/pull/16.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 01 Aug 2018 11:40:05 +1200

docker.io (17.12.1-0ubuntu4) cosmic; urgency=medium

  * d/tests/docker-in-lxd: only setup network bridge if missing

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 05 Jun 2018 22:58:51 -0400

docker.io (17.12.1-0ubuntu3) cosmic; urgency=medium

  * d/tests/docker-in-lxd: switch to ubuntu-daily lxd remote and wait
    for cloud-init to finish before running commands in the container.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 22 May 2018 10:54:00 +1200

docker.io (17.12.1-0ubuntu2) cosmic; urgency=medium

  * Update btrfs dependencies to use the new libbtrfs-dev & btrfs-progs.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 17 May 2018 09:27:15 +0100
