=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders: Docker Packaging Team <docker-maint@lists.alioth.debian.org>,
           Tianon Gravi <tianon@debian.org>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: bash-completion,
               ca-certificates,
               cmake,
               debconf (>= 0.5),
               debhelper (>= 9.20160709~),
               dh-apparmor,
               dh-exec,
               git,
               golang-any (>= 2:1.10~),
               libapparmor-dev,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libdevmapper-dev (>= 2:1.02.68~),
               libltdl-dev,
               libseccomp-dev,
               pkg-config,
               procps,
               tzdata
Standards-Version: 3.9.8
Homepage: https://www.docker.com/community-edition
Vcs-Git: https://anonscm.debian.org/git/docker/docker.io.git
Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker.io.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: adduser, iptables, ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates,
            cgroupfs-mount | cgroup-lite,
            git,
            pigz,
            ubuntu-fan,
            xz-utils,
            ${apparmor:Recommends}
Provides: docker-containerd, docker-runc
Conflicts: docker-containerd, docker-runc
Replaces: docker (<< 1.5~), docker-containerd, docker-runc
Breaks: docker (<< 1.5~)
Suggests: aufs-tools,
          btrfs-progs,
          debootstrap,
          docker-doc,
          rinse,
          zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: ${misc:Depends}
Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
Provides: golang-docker-dev
Description: Externally reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: golang-docker-dev
Section: oldlibs
Priority: optional
Architecture: all
Depends: golang-github-docker-docker-dev, ${misc:Depends}
Description: Transitional package for golang-github-docker-docker-dev
 This is a transitional package to ease upgrades to the
 golang-github-docker-docker-dev package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.
